import ex.accounts.BankAccount;
import ex.comms.Communicator;
import ex.exchange.CurrencyExchange;

public class Accounts {
    public static void main(String [] args)
	throws Exception
    {
	args = aos.jack.Kernel.init(args);

	CurrencyExchange cashier = new CurrencyExchange("edith");
	BankAccount accounts = new BankAccount("anne", cashier.name());

	Communicator communicator
	    = new Communicator("tony", cashier.name(), accounts.name());

	communicator.setRate("AUD", "USD", 0.50);
	communicator.setRate("YEN", "AUD", 0.0165);
	communicator.setRate("GBP", "YEN", 200.0);

	int peter = createAccount(communicator, "Peter", "AUD", 100.0);
	int penny = createAccount(communicator, "Penny", "USD", 15.0);
	int patrick = createAccount(communicator, "Patrick", "AUD", 20.0);

	creditAccount(communicator, penny, "USD", 40.0);
	creditAccount(communicator, penny, "GBP", 40.0);
	creditAccount(communicator, patrick, "USD", 100.0);
	debitAccount(communicator, penny, "YEN", 500.0);
	debitAccount(communicator, peter, "AUD", 50.0);
	creditAccount(communicator, penny, "AUD", 100.0);
	debitAccount(communicator, penny, "USD", 5000.0);
	creditAccount(communicator, penny, "USD", 75.0);
    }

    public static int createAccount(
	Communicator communicator, String name, String currency, double openingBalance)
	throws Exception
    {
	int accountNumber
	    = communicator.createAccount(name, currency, openingBalance);
	System.out.println(
	    "Created account " + accountNumber
	    + " for " + name
	    + " in " + currency
	    + " with opening balance " + openingBalance);
	return accountNumber;
    }

    public static void creditAccount(
	Communicator communicator, int accountNumber, String currency, double amount)
	throws Exception
    {
	if(communicator.creditAccount(accountNumber, currency, amount)) {
	    System.out.println(
		"Credited account " + accountNumber
		+ " with " + currency + amount
		+ ".  Balance: " + communicator.accountBalance(accountNumber));
	} else {
	    System.out.println("Couldn't credit account " + accountNumber);
	}
    }

    public static void debitAccount(
	Communicator communicator, int accountNumber, String currency, double amount)
	throws Exception
    {
	if(communicator.debitAccount(accountNumber, currency, amount)) {
	    System.out.println(
		"Debited account " + accountNumber
		+ " with " + currency + amount
		+ ".  Balance: " + communicator.accountBalance(accountNumber));
	} else {
	    System.out.println("Couldn't debit account " + accountNumber);
	}
    }
}
