import java.awt.*;
import java.util.Date;
import aos.util.Properties;

/**
   The TrafficGUI class is a simple presentation of a schedule.
*/
class TrafficGUI extends Frame {

    List list;

    TrafficGUI(String name)
    {
	super(name);
	String prefix = "ATC.Traffic."+name;
	int x = Properties.getIntProperty(prefix+".x",0);
	int y = Properties.getIntProperty(prefix+".y",0);
	int w = Properties.getIntProperty(prefix+".width",-1);
	int h = Properties.getIntProperty(prefix+".height",0);
	String font =
	    Properties.getStringProperty(prefix+".font","Courier-14");

	setFont(Font.decode(font));
	if (w != -1)
	    setSize(w,h);

	ScrollPane s = new ScrollPane();

	Label label = new Label("Callsign depart  1st ETA   Arrive    ETA");
	add(label,"North");

	list = new List();
	s.add(list);

	add(s,"Center");

	setLocation(x,y);
	show();
    }

    public static String time(long t)
    {
	Date d = new Date(t);
	String s = d.toString();
	int i = s.length()-17;
	return s.substring(i,i+8);
    }

    String keyPart(String value)
    {
	int i = value.lastIndexOf(' ');
	return value.substring(i+1);
    }

    int index(String key)
    {
	String [] item = list.getItems();
	if (item == null)
	    return -1;
	for (int i=0; i<item.length; i++) {
	    if (key.length() > keyPart(item[i]).length())
		return i;
	    if (key.compareTo(keyPart(item[i])) >= 0)
		return i;
	}
	return item.length;
    }

    boolean sameRow(String key,int index)
    {
	String [] item = list.getItems();
	if (index >= item.length)
	    return false;
	return (key.compareTo(keyPart(item[index])) == 0);
    }

    void addRow(long t,String value)
    {
	String key = Long.toString(t);
	String row = " "+value + " " + key;
	int i = index(key);
	if (i == -1) {
	    list.addItem(row);
	} else if (sameRow(key,i)) {
	    list.replaceItem(row,i);
	} else {
	    list.addItem(row,i);
	}
    }

    void removeRow(long t)
    {
	String key = time(t);
	int i = index(key);
	if (i == -1)
	    return;
	if (sameRow(key,i))
	    list.remove(i);
    }
}
