import java.awt.*;
import java.awt.event.*;
import aos.util.Properties;

/**
   The Front class is just a decorative banner, but terminates the
   application when the banner is closed.
*/
class Front extends Frame {

    Front()
    {
	super("Demo");
	String prefix = "ATC.Front";
	int x = Properties.getIntProperty(prefix+".x",0);
	int y = Properties.getIntProperty(prefix+".y",0);
	int w = Properties.getIntProperty(prefix+".width",-1);
	int h = Properties.getIntProperty(prefix+".height",0);
	String font =
	    Properties.getStringProperty(prefix+".font","Courier-bold-48");

	setFont(Font.decode(font));
	add(new Label("Sydney Airport Arrival Scheduling"));
	pack();
	setLocation(x,y);
	addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent e)
	    {
		// Crasch and bang
		System.exit(0);
	    }
	});
	if (w != -1)
	    setSize(w,h);
	show();
	try { Thread.sleep(3); }
	catch (InterruptedException e) { }
    }
}
